// Code generated by go-swagger; DO NOT EDIT.

package infrastructure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/cvn-simulator/cvnsimmodel"
)

// DeleteServiceSwitchV1Reader is a Reader for the DeleteServiceSwitchV1 structure.
type DeleteServiceSwitchV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteServiceSwitchV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteServiceSwitchV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewDeleteServiceSwitchV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewDeleteServiceSwitchV1Unauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteServiceSwitchV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteServiceSwitchV1NotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 405:
		result := NewDeleteServiceSwitchV1MethodNotAllowed()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteServiceSwitchV1UnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteServiceSwitchV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteServiceSwitchV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteServiceSwitchV1OK creates a DeleteServiceSwitchV1OK with default headers values
func NewDeleteServiceSwitchV1OK() *DeleteServiceSwitchV1OK {
	return &DeleteServiceSwitchV1OK{}
}

/*DeleteServiceSwitchV1OK handles this case with default header values.

Deleted data switch
*/
type DeleteServiceSwitchV1OK struct {
	Payload *cvnsimmodel.ServiceSwitchV1
}

func (o *DeleteServiceSwitchV1OK) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1OK  %+v", 200, o.Payload)
}

func (o *DeleteServiceSwitchV1OK) GetPayload() *cvnsimmodel.ServiceSwitchV1 {
	return o.Payload
}

func (o *DeleteServiceSwitchV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.ServiceSwitchV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1BadRequest creates a DeleteServiceSwitchV1BadRequest with default headers values
func NewDeleteServiceSwitchV1BadRequest() *DeleteServiceSwitchV1BadRequest {
	return &DeleteServiceSwitchV1BadRequest{}
}

/*DeleteServiceSwitchV1BadRequest handles this case with default header values.

Bad Request
*/
type DeleteServiceSwitchV1BadRequest struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1BadRequest) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1BadRequest  %+v", 400, o.Payload)
}

func (o *DeleteServiceSwitchV1BadRequest) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1Unauthorized creates a DeleteServiceSwitchV1Unauthorized with default headers values
func NewDeleteServiceSwitchV1Unauthorized() *DeleteServiceSwitchV1Unauthorized {
	return &DeleteServiceSwitchV1Unauthorized{}
}

/*DeleteServiceSwitchV1Unauthorized handles this case with default header values.

Unauthorized
*/
type DeleteServiceSwitchV1Unauthorized struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1Unauthorized) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1Unauthorized  %+v", 401, o.Payload)
}

func (o *DeleteServiceSwitchV1Unauthorized) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1Unauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1Forbidden creates a DeleteServiceSwitchV1Forbidden with default headers values
func NewDeleteServiceSwitchV1Forbidden() *DeleteServiceSwitchV1Forbidden {
	return &DeleteServiceSwitchV1Forbidden{}
}

/*DeleteServiceSwitchV1Forbidden handles this case with default header values.

Forbidden
*/
type DeleteServiceSwitchV1Forbidden struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1Forbidden) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1Forbidden  %+v", 403, o.Payload)
}

func (o *DeleteServiceSwitchV1Forbidden) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1NotFound creates a DeleteServiceSwitchV1NotFound with default headers values
func NewDeleteServiceSwitchV1NotFound() *DeleteServiceSwitchV1NotFound {
	return &DeleteServiceSwitchV1NotFound{}
}

/*DeleteServiceSwitchV1NotFound handles this case with default header values.

Not found
*/
type DeleteServiceSwitchV1NotFound struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1NotFound) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1NotFound  %+v", 404, o.Payload)
}

func (o *DeleteServiceSwitchV1NotFound) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1NotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1MethodNotAllowed creates a DeleteServiceSwitchV1MethodNotAllowed with default headers values
func NewDeleteServiceSwitchV1MethodNotAllowed() *DeleteServiceSwitchV1MethodNotAllowed {
	return &DeleteServiceSwitchV1MethodNotAllowed{}
}

/*DeleteServiceSwitchV1MethodNotAllowed handles this case with default header values.

Method not allowed
*/
type DeleteServiceSwitchV1MethodNotAllowed struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1MethodNotAllowed) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1MethodNotAllowed  %+v", 405, o.Payload)
}

func (o *DeleteServiceSwitchV1MethodNotAllowed) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1MethodNotAllowed) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1UnprocessableEntity creates a DeleteServiceSwitchV1UnprocessableEntity with default headers values
func NewDeleteServiceSwitchV1UnprocessableEntity() *DeleteServiceSwitchV1UnprocessableEntity {
	return &DeleteServiceSwitchV1UnprocessableEntity{}
}

/*DeleteServiceSwitchV1UnprocessableEntity handles this case with default header values.

Unprocessable Entity
*/
type DeleteServiceSwitchV1UnprocessableEntity struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1UnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1UnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteServiceSwitchV1UnprocessableEntity) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1UnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1InternalServerError creates a DeleteServiceSwitchV1InternalServerError with default headers values
func NewDeleteServiceSwitchV1InternalServerError() *DeleteServiceSwitchV1InternalServerError {
	return &DeleteServiceSwitchV1InternalServerError{}
}

/*DeleteServiceSwitchV1InternalServerError handles this case with default header values.

Internal server error
*/
type DeleteServiceSwitchV1InternalServerError struct {
	Payload *cvnsimmodel.Error
}

func (o *DeleteServiceSwitchV1InternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitchV1InternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteServiceSwitchV1InternalServerError) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteServiceSwitchV1Default creates a DeleteServiceSwitchV1Default with default headers values
func NewDeleteServiceSwitchV1Default(code int) *DeleteServiceSwitchV1Default {
	return &DeleteServiceSwitchV1Default{
		_statusCode: code,
	}
}

/*DeleteServiceSwitchV1Default handles this case with default header values.

Unexpected error
*/
type DeleteServiceSwitchV1Default struct {
	_statusCode int

	Payload *cvnsimmodel.Error
}

// Code gets the status code for the delete service switch v1 default response
func (o *DeleteServiceSwitchV1Default) Code() int {
	return o._statusCode
}

func (o *DeleteServiceSwitchV1Default) Error() string {
	return fmt.Sprintf("[DELETE /v1/serviceswitch/{uuid}][%d] deleteServiceSwitch_v1 default  %+v", o._statusCode, o.Payload)
}

func (o *DeleteServiceSwitchV1Default) GetPayload() *cvnsimmodel.Error {
	return o.Payload
}

func (o *DeleteServiceSwitchV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cvnsimmodel.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
