// Code generated by go-swagger; DO NOT EDIT.

package infrastructure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new infrastructure API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for infrastructure API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
CreateServiceSwitchV1 creates a new service switch

Create a new service switch.
*/
func (a *Client) CreateServiceSwitchV1(params *CreateServiceSwitchV1Params) (*CreateServiceSwitchV1Created, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewCreateServiceSwitchV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "createServiceSwitch_v1",
		Method:             "POST",
		PathPattern:        "/v1/serviceswitch",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &CreateServiceSwitchV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*CreateServiceSwitchV1Created)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*CreateServiceSwitchV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
DeleteServiceSwitchV1 deletes a service switch

Warning! This operation will permanently delete the service switch.
*/
func (a *Client) DeleteServiceSwitchV1(params *DeleteServiceSwitchV1Params) (*DeleteServiceSwitchV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteServiceSwitchV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteServiceSwitch_v1",
		Method:             "DELETE",
		PathPattern:        "/v1/serviceswitch/{uuid}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DeleteServiceSwitchV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteServiceSwitchV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*DeleteServiceSwitchV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
DescribeServiceSwitchV1 describes a service switch

Returns the description of the specified service switch by UUID.
*/
func (a *Client) DescribeServiceSwitchV1(params *DescribeServiceSwitchV1Params) (*DescribeServiceSwitchV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDescribeServiceSwitchV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "describeServiceSwitch_v1",
		Method:             "GET",
		PathPattern:        "/v1/serviceswitch/{uuid}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DescribeServiceSwitchV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DescribeServiceSwitchV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*DescribeServiceSwitchV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
ListServiceSwitchesV1 describes all service switches

Returns the description of all service switches
*/
func (a *Client) ListServiceSwitchesV1(params *ListServiceSwitchesV1Params) (*ListServiceSwitchesV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewListServiceSwitchesV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listServiceSwitches_v1",
		Method:             "GET",
		PathPattern:        "/v1/serviceswitch",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListServiceSwitchesV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*ListServiceSwitchesV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*ListServiceSwitchesV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
UpdateServiceSwitchV1 updates a service switch

Updates the service switch properties with the full spec
*/
func (a *Client) UpdateServiceSwitchV1(params *UpdateServiceSwitchV1Params) (*UpdateServiceSwitchV1OK, *UpdateServiceSwitchV1NoContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateServiceSwitchV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateServiceSwitch_v1",
		Method:             "PUT",
		PathPattern:        "/v1/serviceswitch/{uuid}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateServiceSwitchV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, nil, err
	}
	switch value := result.(type) {
	case *UpdateServiceSwitchV1OK:
		return value, nil, nil
	case *UpdateServiceSwitchV1NoContent:
		return nil, value, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*UpdateServiceSwitchV1Default)
	return nil, nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
