// Code generated by go-swagger; DO NOT EDIT.

package cvnsimmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ServiceSwitchV1 serviceswitch
// swagger:model ServiceSwitch_v1
type ServiceSwitchV1 struct {
	ResourceV1

	// asn
	//
	// The asn of serviceswitch
	// Read Only: true
	Asn uint32 `json:"asn,omitempty"`

	// caCert
	//
	// The CA certificate of the data switch
	CaCert string `json:"caCert,omitempty"`

	// capacity
	//
	// The tenant capacity of this switch
	Capacity *uint32 `json:"capacity,omitempty"`

	// host
	//
	// The host of the data switch
	// Required: true
	Host *string `json:"host"`

	// isPrimary
	//
	// Flag indicating whether the service switch is primary.
	IsPrimary *bool `json:"isPrimary,omitempty"`

	// microzoneUUID
	//
	// The UUID of the microzone the data switch belongs to
	// Required: true
	// Max Length: 36
	// Min Length: 36
	// Pattern: ^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$
	MicrozoneUUID *string `json:"microzoneUUID"`

	// model
	//
	// The model of the data switch
	// Required: true
	// Enum: [nxos]
	Model *string `json:"model"`

	// name
	//
	// The name of the data switch
	Name string `json:"name,omitempty"`

	// password
	//
	// The password for the data switch
	// Required: true
	Password *string `json:"password"`

	// tenancy
	//
	// The current tenancy count
	// Read Only: true
	Tenancy *uint32 `json:"tenancy,omitempty"`

	// username
	//
	// The username for the data switch
	// Required: true
	Username *string `json:"username"`

	// vtep
	//
	// The vtep of serviceswitch
	// Max Length: 20
	// Min Length: 1
	Vtep string `json:"vtep,omitempty"`
}

// UnmarshalJSON unmarshals this object from a JSON structure
func (m *ServiceSwitchV1) UnmarshalJSON(raw []byte) error {
	// AO0
	var aO0 ResourceV1
	if err := swag.ReadJSON(raw, &aO0); err != nil {
		return err
	}
	m.ResourceV1 = aO0

	// AO1
	var dataAO1 struct {
		Asn uint32 `json:"asn,omitempty"`

		CaCert string `json:"caCert,omitempty"`

		Capacity *uint32 `json:"capacity,omitempty"`

		Host *string `json:"host"`

		IsPrimary *bool `json:"isPrimary,omitempty"`

		MicrozoneUUID *string `json:"microzoneUUID"`

		Model *string `json:"model"`

		Name string `json:"name,omitempty"`

		Password *string `json:"password"`

		Tenancy *uint32 `json:"tenancy,omitempty"`

		Username *string `json:"username"`

		Vtep string `json:"vtep,omitempty"`
	}
	if err := swag.ReadJSON(raw, &dataAO1); err != nil {
		return err
	}

	m.Asn = dataAO1.Asn

	m.CaCert = dataAO1.CaCert

	m.Capacity = dataAO1.Capacity

	m.Host = dataAO1.Host

	m.IsPrimary = dataAO1.IsPrimary

	m.MicrozoneUUID = dataAO1.MicrozoneUUID

	m.Model = dataAO1.Model

	m.Name = dataAO1.Name

	m.Password = dataAO1.Password

	m.Tenancy = dataAO1.Tenancy

	m.Username = dataAO1.Username

	m.Vtep = dataAO1.Vtep

	return nil
}

// MarshalJSON marshals this object to a JSON structure
func (m ServiceSwitchV1) MarshalJSON() ([]byte, error) {
	_parts := make([][]byte, 0, 2)

	aO0, err := swag.WriteJSON(m.ResourceV1)
	if err != nil {
		return nil, err
	}
	_parts = append(_parts, aO0)

	var dataAO1 struct {
		Asn uint32 `json:"asn,omitempty"`

		CaCert string `json:"caCert,omitempty"`

		Capacity *uint32 `json:"capacity,omitempty"`

		Host *string `json:"host"`

		IsPrimary *bool `json:"isPrimary,omitempty"`

		MicrozoneUUID *string `json:"microzoneUUID"`

		Model *string `json:"model"`

		Name string `json:"name,omitempty"`

		Password *string `json:"password"`

		Tenancy *uint32 `json:"tenancy,omitempty"`

		Username *string `json:"username"`

		Vtep string `json:"vtep,omitempty"`
	}

	dataAO1.Asn = m.Asn

	dataAO1.CaCert = m.CaCert

	dataAO1.Capacity = m.Capacity

	dataAO1.Host = m.Host

	dataAO1.IsPrimary = m.IsPrimary

	dataAO1.MicrozoneUUID = m.MicrozoneUUID

	dataAO1.Model = m.Model

	dataAO1.Name = m.Name

	dataAO1.Password = m.Password

	dataAO1.Tenancy = m.Tenancy

	dataAO1.Username = m.Username

	dataAO1.Vtep = m.Vtep

	jsonDataAO1, errAO1 := swag.WriteJSON(dataAO1)
	if errAO1 != nil {
		return nil, errAO1
	}
	_parts = append(_parts, jsonDataAO1)

	return swag.ConcatJSON(_parts...), nil
}

// Validate validates this service switch v1
func (m *ServiceSwitchV1) Validate(formats strfmt.Registry) error {
	var res []error

	// validation for a type composition with ResourceV1
	if err := m.ResourceV1.Validate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHost(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMicrozoneUUID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateModel(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePassword(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUsername(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVtep(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceSwitchV1) validateHost(formats strfmt.Registry) error {

	if err := validate.Required("host", "body", m.Host); err != nil {
		return err
	}

	return nil
}

func (m *ServiceSwitchV1) validateMicrozoneUUID(formats strfmt.Registry) error {

	if err := validate.Required("microzoneUUID", "body", m.MicrozoneUUID); err != nil {
		return err
	}

	if err := validate.MinLength("microzoneUUID", "body", string(*m.MicrozoneUUID), 36); err != nil {
		return err
	}

	if err := validate.MaxLength("microzoneUUID", "body", string(*m.MicrozoneUUID), 36); err != nil {
		return err
	}

	if err := validate.Pattern("microzoneUUID", "body", string(*m.MicrozoneUUID), `^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$`); err != nil {
		return err
	}

	return nil
}

var serviceSwitchV1TypeModelPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["nxos"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceSwitchV1TypeModelPropEnum = append(serviceSwitchV1TypeModelPropEnum, v)
	}
}

// property enum
func (m *ServiceSwitchV1) validateModelEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, serviceSwitchV1TypeModelPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *ServiceSwitchV1) validateModel(formats strfmt.Registry) error {

	if err := validate.Required("model", "body", m.Model); err != nil {
		return err
	}

	// value enum
	if err := m.validateModelEnum("model", "body", *m.Model); err != nil {
		return err
	}

	return nil
}

func (m *ServiceSwitchV1) validatePassword(formats strfmt.Registry) error {

	if err := validate.Required("password", "body", m.Password); err != nil {
		return err
	}

	return nil
}

func (m *ServiceSwitchV1) validateUsername(formats strfmt.Registry) error {

	if err := validate.Required("username", "body", m.Username); err != nil {
		return err
	}

	return nil
}

func (m *ServiceSwitchV1) validateVtep(formats strfmt.Registry) error {

	if swag.IsZero(m.Vtep) { // not required
		return nil
	}

	if err := validate.MinLength("vtep", "body", string(m.Vtep), 1); err != nil {
		return err
	}

	if err := validate.MaxLength("vtep", "body", string(m.Vtep), 20); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceSwitchV1) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceSwitchV1) UnmarshalBinary(b []byte) error {
	var res ServiceSwitchV1
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
