// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package azure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetRegionClustersParams creates a new GetRegionClustersParams object
// with the default values initialized.
func NewGetRegionClustersParams() *GetRegionClustersParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClustersParams{
		APIVersion: aPIVersionDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetRegionClustersParamsWithTimeout creates a new GetRegionClustersParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetRegionClustersParamsWithTimeout(timeout time.Duration) *GetRegionClustersParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClustersParams{
		APIVersion: aPIVersionDefault,

		timeout: timeout,
	}
}

// NewGetRegionClustersParamsWithContext creates a new GetRegionClustersParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetRegionClustersParamsWithContext(ctx context.Context) *GetRegionClustersParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClustersParams{
		APIVersion: apiVersionDefault,

		Context: ctx,
	}
}

// NewGetRegionClustersParamsWithHTTPClient creates a new GetRegionClustersParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetRegionClustersParamsWithHTTPClient(client *http.Client) *GetRegionClustersParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClustersParams{
		APIVersion: apiVersionDefault,
		HTTPClient: client,
	}
}

/*GetRegionClustersParams contains all the parameters to send to the API endpoint
for the get region clusters operation typically these are written to a http.Request
*/
type GetRegionClustersParams struct {

	/*Region
	  Region name

	*/
	Region string
	/*APIVersion
	  Version of the API to be used with the client request.

	*/
	APIVersion string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get region clusters params
func (o *GetRegionClustersParams) WithTimeout(timeout time.Duration) *GetRegionClustersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get region clusters params
func (o *GetRegionClustersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get region clusters params
func (o *GetRegionClustersParams) WithContext(ctx context.Context) *GetRegionClustersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get region clusters params
func (o *GetRegionClustersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get region clusters params
func (o *GetRegionClustersParams) WithHTTPClient(client *http.Client) *GetRegionClustersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get region clusters params
func (o *GetRegionClustersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegion adds the region to the get region clusters params
func (o *GetRegionClustersParams) WithRegion(region string) *GetRegionClustersParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the get region clusters params
func (o *GetRegionClustersParams) SetRegion(region string) {
	o.Region = region
}

// WithAPIVersion adds the aPIVersion to the get region clusters params
func (o *GetRegionClustersParams) WithAPIVersion(aPIVersion string) *GetRegionClustersParams {
	o.SetAPIVersion(aPIVersion)
	return o
}

// SetAPIVersion adds the apiVersion to the get region clusters params
func (o *GetRegionClustersParams) SetAPIVersion(aPIVersion string) {
	o.APIVersion = aPIVersion
}

// WriteToRequest writes these params to a swagger request
func (o *GetRegionClustersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param Region
	if err := r.SetPathParam("Region", o.Region); err != nil {
		return err
	}

	// query param api-version
	qrAPIVersion := o.APIVersion
	qAPIVersion := qrAPIVersion
	if qAPIVersion != "" {
		if err := r.SetQueryParam("api-version", qAPIVersion); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
