// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package azure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// GetRegionClustersReader is a Reader for the GetRegionClusters structure.
type GetRegionClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRegionClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRegionClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetRegionClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRegionClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRegionClustersDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRegionClustersOK creates a GetRegionClustersOK with default headers values
func NewGetRegionClustersOK() *GetRegionClustersOK {
	return &GetRegionClustersOK{}
}

/*GetRegionClustersOK handles this case with default header values.

List of Cluster with details
*/
type GetRegionClustersOK struct {
	Payload *models.Clusters
}

func (o *GetRegionClustersOK) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/Region/{Region}][%d] getRegionClustersOK  %+v", 200, o.Payload)
}

func (o *GetRegionClustersOK) GetPayload() *models.Clusters {
	return o.Payload
}

func (o *GetRegionClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Clusters)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionClustersNotFound creates a GetRegionClustersNotFound with default headers values
func NewGetRegionClustersNotFound() *GetRegionClustersNotFound {
	return &GetRegionClustersNotFound{}
}

/*GetRegionClustersNotFound handles this case with default header values.

Not found
*/
type GetRegionClustersNotFound struct {
	Payload *models.Error
}

func (o *GetRegionClustersNotFound) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/Region/{Region}][%d] getRegionClustersNotFound  %+v", 404, o.Payload)
}

func (o *GetRegionClustersNotFound) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionClustersInternalServerError creates a GetRegionClustersInternalServerError with default headers values
func NewGetRegionClustersInternalServerError() *GetRegionClustersInternalServerError {
	return &GetRegionClustersInternalServerError{}
}

/*GetRegionClustersInternalServerError handles this case with default header values.

Internal server error
*/
type GetRegionClustersInternalServerError struct {
	Payload *models.Error
}

func (o *GetRegionClustersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/Region/{Region}][%d] getRegionClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetRegionClustersInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionClustersDefault creates a GetRegionClustersDefault with default headers values
func NewGetRegionClustersDefault(code int) *GetRegionClustersDefault {
	return &GetRegionClustersDefault{
		_statusCode: code,
	}
}

/*GetRegionClustersDefault handles this case with default header values.

Error response describing error
*/
type GetRegionClustersDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the get region clusters default response
func (o *GetRegionClustersDefault) Code() int {
	return o._statusCode
}

func (o *GetRegionClustersDefault) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/Region/{Region}][%d] GetRegionClusters default  %+v", o._statusCode, o.Payload)
}

func (o *GetRegionClustersDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionClustersDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
