// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new cluster API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for cluster API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	CreateRegionCluster(params *CreateRegionClusterParams) (*CreateRegionClusterCreated, error)

	GetClusters(params *GetClustersParams) (*GetClustersOK, error)

	GetRegionCluster(params *GetRegionClusterParams) (*GetRegionClusterOK, error)

	UpdateRegionCluster(params *UpdateRegionClusterParams) (*UpdateRegionClusterOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  CreateRegionCluster creates a new cluster in the specified region
*/
func (a *Client) CreateRegionCluster(params *CreateRegionClusterParams) (*CreateRegionClusterCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewCreateRegionClusterParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "CreateRegionCluster",
		Method:             "POST",
		PathPattern:        "/providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &CreateRegionClusterReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*CreateRegionClusterCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*CreateRegionClusterDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  GetClusters lists all clusters and their limits
*/
func (a *Client) GetClusters(params *GetClustersParams) (*GetClustersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetClustersParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "GetClusters",
		Method:             "GET",
		PathPattern:        "/providers/Microsoft.BareMetal/Utilization/Clusters",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json", "application/xml"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetClustersReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetClustersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*GetClustersDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  GetRegionCluster clusters details for the a specific cluster name in the region
*/
func (a *Client) GetRegionCluster(params *GetRegionClusterParams) (*GetRegionClusterOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetRegionClusterParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "GetRegionCluster",
		Method:             "GET",
		PathPattern:        "/providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json", "application/xml"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetRegionClusterReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetRegionClusterOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*GetRegionClusterDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  UpdateRegionCluster updates values in a cluster

  Update values in a cluster
*/
func (a *Client) UpdateRegionCluster(params *UpdateRegionClusterParams) (*UpdateRegionClusterOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateRegionClusterParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "UpdateRegionCluster",
		Method:             "PUT",
		PathPattern:        "/providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateRegionClusterReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*UpdateRegionClusterOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*UpdateRegionClusterDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
