// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// NewCreateRegionClusterParams creates a new CreateRegionClusterParams object
// with the default values initialized.
func NewCreateRegionClusterParams() *CreateRegionClusterParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &CreateRegionClusterParams{
		APIVersion: aPIVersionDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewCreateRegionClusterParamsWithTimeout creates a new CreateRegionClusterParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewCreateRegionClusterParamsWithTimeout(timeout time.Duration) *CreateRegionClusterParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &CreateRegionClusterParams{
		APIVersion: aPIVersionDefault,

		timeout: timeout,
	}
}

// NewCreateRegionClusterParamsWithContext creates a new CreateRegionClusterParams object
// with the default values initialized, and the ability to set a context for a request
func NewCreateRegionClusterParamsWithContext(ctx context.Context) *CreateRegionClusterParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &CreateRegionClusterParams{
		APIVersion: apiVersionDefault,

		Context: ctx,
	}
}

// NewCreateRegionClusterParamsWithHTTPClient creates a new CreateRegionClusterParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewCreateRegionClusterParamsWithHTTPClient(client *http.Client) *CreateRegionClusterParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &CreateRegionClusterParams{
		APIVersion: apiVersionDefault,
		HTTPClient: client,
	}
}

/*CreateRegionClusterParams contains all the parameters to send to the API endpoint
for the create region cluster operation typically these are written to a http.Request
*/
type CreateRegionClusterParams struct {

	/*Region
	  Region name

	*/
	Region string
	/*APIVersion
	  Version of the API to be used with the client request.

	*/
	APIVersion string
	/*Body
	  The required parameters to create a new cluster.

	*/
	Body *models.Cluster
	/*ClusterName
	  Cluster name

	*/
	ClusterName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the create region cluster params
func (o *CreateRegionClusterParams) WithTimeout(timeout time.Duration) *CreateRegionClusterParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create region cluster params
func (o *CreateRegionClusterParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create region cluster params
func (o *CreateRegionClusterParams) WithContext(ctx context.Context) *CreateRegionClusterParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create region cluster params
func (o *CreateRegionClusterParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create region cluster params
func (o *CreateRegionClusterParams) WithHTTPClient(client *http.Client) *CreateRegionClusterParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create region cluster params
func (o *CreateRegionClusterParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegion adds the region to the create region cluster params
func (o *CreateRegionClusterParams) WithRegion(region string) *CreateRegionClusterParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the create region cluster params
func (o *CreateRegionClusterParams) SetRegion(region string) {
	o.Region = region
}

// WithAPIVersion adds the aPIVersion to the create region cluster params
func (o *CreateRegionClusterParams) WithAPIVersion(aPIVersion string) *CreateRegionClusterParams {
	o.SetAPIVersion(aPIVersion)
	return o
}

// SetAPIVersion adds the apiVersion to the create region cluster params
func (o *CreateRegionClusterParams) SetAPIVersion(aPIVersion string) {
	o.APIVersion = aPIVersion
}

// WithBody adds the body to the create region cluster params
func (o *CreateRegionClusterParams) WithBody(body *models.Cluster) *CreateRegionClusterParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create region cluster params
func (o *CreateRegionClusterParams) SetBody(body *models.Cluster) {
	o.Body = body
}

// WithClusterName adds the clusterName to the create region cluster params
func (o *CreateRegionClusterParams) WithClusterName(clusterName string) *CreateRegionClusterParams {
	o.SetClusterName(clusterName)
	return o
}

// SetClusterName adds the clusterName to the create region cluster params
func (o *CreateRegionClusterParams) SetClusterName(clusterName string) {
	o.ClusterName = clusterName
}

// WriteToRequest writes these params to a swagger request
func (o *CreateRegionClusterParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param Region
	if err := r.SetPathParam("Region", o.Region); err != nil {
		return err
	}

	// query param api-version
	qrAPIVersion := o.APIVersion
	qAPIVersion := qrAPIVersion
	if qAPIVersion != "" {
		if err := r.SetQueryParam("api-version", qAPIVersion); err != nil {
			return err
		}
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param clusterName
	if err := r.SetPathParam("clusterName", o.ClusterName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
