// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// CreateRegionClusterReader is a Reader for the CreateRegionCluster structure.
type CreateRegionClusterReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateRegionClusterReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateRegionClusterCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 409:
		result := NewCreateRegionClusterConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateRegionClusterInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewCreateRegionClusterDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCreateRegionClusterCreated creates a CreateRegionClusterCreated with default headers values
func NewCreateRegionClusterCreated() *CreateRegionClusterCreated {
	return &CreateRegionClusterCreated{}
}

/*CreateRegionClusterCreated handles this case with default header values.

Details of the new cluster created
*/
type CreateRegionClusterCreated struct {
	Payload *models.Cluster
}

func (o *CreateRegionClusterCreated) Error() string {
	return fmt.Sprintf("[POST /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] createRegionClusterCreated  %+v", 201, o.Payload)
}

func (o *CreateRegionClusterCreated) GetPayload() *models.Cluster {
	return o.Payload
}

func (o *CreateRegionClusterCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Cluster)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRegionClusterConflict creates a CreateRegionClusterConflict with default headers values
func NewCreateRegionClusterConflict() *CreateRegionClusterConflict {
	return &CreateRegionClusterConflict{}
}

/*CreateRegionClusterConflict handles this case with default header values.

Conflict
*/
type CreateRegionClusterConflict struct {
	Payload *models.Error
}

func (o *CreateRegionClusterConflict) Error() string {
	return fmt.Sprintf("[POST /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] createRegionClusterConflict  %+v", 409, o.Payload)
}

func (o *CreateRegionClusterConflict) GetPayload() *models.Error {
	return o.Payload
}

func (o *CreateRegionClusterConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRegionClusterInternalServerError creates a CreateRegionClusterInternalServerError with default headers values
func NewCreateRegionClusterInternalServerError() *CreateRegionClusterInternalServerError {
	return &CreateRegionClusterInternalServerError{}
}

/*CreateRegionClusterInternalServerError handles this case with default header values.

Internal server error
*/
type CreateRegionClusterInternalServerError struct {
	Payload *models.Error
}

func (o *CreateRegionClusterInternalServerError) Error() string {
	return fmt.Sprintf("[POST /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] createRegionClusterInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateRegionClusterInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *CreateRegionClusterInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRegionClusterDefault creates a CreateRegionClusterDefault with default headers values
func NewCreateRegionClusterDefault(code int) *CreateRegionClusterDefault {
	return &CreateRegionClusterDefault{
		_statusCode: code,
	}
}

/*CreateRegionClusterDefault handles this case with default header values.

Error response describing why the operation failed
*/
type CreateRegionClusterDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the create region cluster default response
func (o *CreateRegionClusterDefault) Code() int {
	return o._statusCode
}

func (o *CreateRegionClusterDefault) Error() string {
	return fmt.Sprintf("[POST /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] CreateRegionCluster default  %+v", o._statusCode, o.Payload)
}

func (o *CreateRegionClusterDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *CreateRegionClusterDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
