// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetRegionClusterParams creates a new GetRegionClusterParams object
// with the default values initialized.
func NewGetRegionClusterParams() *GetRegionClusterParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClusterParams{
		APIVersion: aPIVersionDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetRegionClusterParamsWithTimeout creates a new GetRegionClusterParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetRegionClusterParamsWithTimeout(timeout time.Duration) *GetRegionClusterParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClusterParams{
		APIVersion: aPIVersionDefault,

		timeout: timeout,
	}
}

// NewGetRegionClusterParamsWithContext creates a new GetRegionClusterParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetRegionClusterParamsWithContext(ctx context.Context) *GetRegionClusterParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClusterParams{
		APIVersion: apiVersionDefault,

		Context: ctx,
	}
}

// NewGetRegionClusterParamsWithHTTPClient creates a new GetRegionClusterParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetRegionClusterParamsWithHTTPClient(client *http.Client) *GetRegionClusterParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionClusterParams{
		APIVersion: apiVersionDefault,
		HTTPClient: client,
	}
}

/*GetRegionClusterParams contains all the parameters to send to the API endpoint
for the get region cluster operation typically these are written to a http.Request
*/
type GetRegionClusterParams struct {

	/*Region
	  Region name

	*/
	Region string
	/*APIVersion
	  Version of the API to be used with the client request.

	*/
	APIVersion string
	/*ClusterName
	  Cluster name

	*/
	ClusterName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get region cluster params
func (o *GetRegionClusterParams) WithTimeout(timeout time.Duration) *GetRegionClusterParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get region cluster params
func (o *GetRegionClusterParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get region cluster params
func (o *GetRegionClusterParams) WithContext(ctx context.Context) *GetRegionClusterParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get region cluster params
func (o *GetRegionClusterParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get region cluster params
func (o *GetRegionClusterParams) WithHTTPClient(client *http.Client) *GetRegionClusterParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get region cluster params
func (o *GetRegionClusterParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegion adds the region to the get region cluster params
func (o *GetRegionClusterParams) WithRegion(region string) *GetRegionClusterParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the get region cluster params
func (o *GetRegionClusterParams) SetRegion(region string) {
	o.Region = region
}

// WithAPIVersion adds the aPIVersion to the get region cluster params
func (o *GetRegionClusterParams) WithAPIVersion(aPIVersion string) *GetRegionClusterParams {
	o.SetAPIVersion(aPIVersion)
	return o
}

// SetAPIVersion adds the apiVersion to the get region cluster params
func (o *GetRegionClusterParams) SetAPIVersion(aPIVersion string) {
	o.APIVersion = aPIVersion
}

// WithClusterName adds the clusterName to the get region cluster params
func (o *GetRegionClusterParams) WithClusterName(clusterName string) *GetRegionClusterParams {
	o.SetClusterName(clusterName)
	return o
}

// SetClusterName adds the clusterName to the get region cluster params
func (o *GetRegionClusterParams) SetClusterName(clusterName string) {
	o.ClusterName = clusterName
}

// WriteToRequest writes these params to a swagger request
func (o *GetRegionClusterParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param Region
	if err := r.SetPathParam("Region", o.Region); err != nil {
		return err
	}

	// query param api-version
	qrAPIVersion := o.APIVersion
	qAPIVersion := qrAPIVersion
	if qAPIVersion != "" {
		if err := r.SetQueryParam("api-version", qAPIVersion); err != nil {
			return err
		}
	}

	// path param clusterName
	if err := r.SetPathParam("clusterName", o.ClusterName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
