// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// GetRegionClusterReader is a Reader for the GetRegionCluster structure.
type GetRegionClusterReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRegionClusterReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRegionClusterOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetRegionClusterNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRegionClusterInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRegionClusterDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRegionClusterOK creates a GetRegionClusterOK with default headers values
func NewGetRegionClusterOK() *GetRegionClusterOK {
	return &GetRegionClusterOK{}
}

/*GetRegionClusterOK handles this case with default header values.

Details of a particular cluster
*/
type GetRegionClusterOK struct {
	Payload *models.Cluster
}

func (o *GetRegionClusterOK) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] getRegionClusterOK  %+v", 200, o.Payload)
}

func (o *GetRegionClusterOK) GetPayload() *models.Cluster {
	return o.Payload
}

func (o *GetRegionClusterOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Cluster)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionClusterNotFound creates a GetRegionClusterNotFound with default headers values
func NewGetRegionClusterNotFound() *GetRegionClusterNotFound {
	return &GetRegionClusterNotFound{}
}

/*GetRegionClusterNotFound handles this case with default header values.

Not found
*/
type GetRegionClusterNotFound struct {
	Payload *models.Error
}

func (o *GetRegionClusterNotFound) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] getRegionClusterNotFound  %+v", 404, o.Payload)
}

func (o *GetRegionClusterNotFound) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionClusterNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionClusterInternalServerError creates a GetRegionClusterInternalServerError with default headers values
func NewGetRegionClusterInternalServerError() *GetRegionClusterInternalServerError {
	return &GetRegionClusterInternalServerError{}
}

/*GetRegionClusterInternalServerError handles this case with default header values.

Internal server error
*/
type GetRegionClusterInternalServerError struct {
	Payload *models.Error
}

func (o *GetRegionClusterInternalServerError) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] getRegionClusterInternalServerError  %+v", 500, o.Payload)
}

func (o *GetRegionClusterInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionClusterInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionClusterDefault creates a GetRegionClusterDefault with default headers values
func NewGetRegionClusterDefault(code int) *GetRegionClusterDefault {
	return &GetRegionClusterDefault{
		_statusCode: code,
	}
}

/*GetRegionClusterDefault handles this case with default header values.

Error response describing why the operation failed
*/
type GetRegionClusterDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the get region cluster default response
func (o *GetRegionClusterDefault) Code() int {
	return o._statusCode
}

func (o *GetRegionClusterDefault) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] GetRegionCluster default  %+v", o._statusCode, o.Payload)
}

func (o *GetRegionClusterDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionClusterDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
