// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// NewUpdateRegionClusterParams creates a new UpdateRegionClusterParams object
// with the default values initialized.
func NewUpdateRegionClusterParams() *UpdateRegionClusterParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &UpdateRegionClusterParams{
		APIVersion: aPIVersionDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateRegionClusterParamsWithTimeout creates a new UpdateRegionClusterParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewUpdateRegionClusterParamsWithTimeout(timeout time.Duration) *UpdateRegionClusterParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &UpdateRegionClusterParams{
		APIVersion: aPIVersionDefault,

		timeout: timeout,
	}
}

// NewUpdateRegionClusterParamsWithContext creates a new UpdateRegionClusterParams object
// with the default values initialized, and the ability to set a context for a request
func NewUpdateRegionClusterParamsWithContext(ctx context.Context) *UpdateRegionClusterParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &UpdateRegionClusterParams{
		APIVersion: apiVersionDefault,

		Context: ctx,
	}
}

// NewUpdateRegionClusterParamsWithHTTPClient creates a new UpdateRegionClusterParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewUpdateRegionClusterParamsWithHTTPClient(client *http.Client) *UpdateRegionClusterParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &UpdateRegionClusterParams{
		APIVersion: apiVersionDefault,
		HTTPClient: client,
	}
}

/*UpdateRegionClusterParams contains all the parameters to send to the API endpoint
for the update region cluster operation typically these are written to a http.Request
*/
type UpdateRegionClusterParams struct {

	/*Region
	  Region name

	*/
	Region string
	/*APIVersion
	  Version of the API to be used with the client request.

	*/
	APIVersion string
	/*Body
	  The required parameters to update a cluster VRFcount, routeCount or allocatedRoutes.

	*/
	Body *models.Cluster
	/*ClusterName
	  Cluster name

	*/
	ClusterName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the update region cluster params
func (o *UpdateRegionClusterParams) WithTimeout(timeout time.Duration) *UpdateRegionClusterParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update region cluster params
func (o *UpdateRegionClusterParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update region cluster params
func (o *UpdateRegionClusterParams) WithContext(ctx context.Context) *UpdateRegionClusterParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update region cluster params
func (o *UpdateRegionClusterParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update region cluster params
func (o *UpdateRegionClusterParams) WithHTTPClient(client *http.Client) *UpdateRegionClusterParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update region cluster params
func (o *UpdateRegionClusterParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegion adds the region to the update region cluster params
func (o *UpdateRegionClusterParams) WithRegion(region string) *UpdateRegionClusterParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the update region cluster params
func (o *UpdateRegionClusterParams) SetRegion(region string) {
	o.Region = region
}

// WithAPIVersion adds the aPIVersion to the update region cluster params
func (o *UpdateRegionClusterParams) WithAPIVersion(aPIVersion string) *UpdateRegionClusterParams {
	o.SetAPIVersion(aPIVersion)
	return o
}

// SetAPIVersion adds the apiVersion to the update region cluster params
func (o *UpdateRegionClusterParams) SetAPIVersion(aPIVersion string) {
	o.APIVersion = aPIVersion
}

// WithBody adds the body to the update region cluster params
func (o *UpdateRegionClusterParams) WithBody(body *models.Cluster) *UpdateRegionClusterParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update region cluster params
func (o *UpdateRegionClusterParams) SetBody(body *models.Cluster) {
	o.Body = body
}

// WithClusterName adds the clusterName to the update region cluster params
func (o *UpdateRegionClusterParams) WithClusterName(clusterName string) *UpdateRegionClusterParams {
	o.SetClusterName(clusterName)
	return o
}

// SetClusterName adds the clusterName to the update region cluster params
func (o *UpdateRegionClusterParams) SetClusterName(clusterName string) {
	o.ClusterName = clusterName
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateRegionClusterParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param Region
	if err := r.SetPathParam("Region", o.Region); err != nil {
		return err
	}

	// query param api-version
	qrAPIVersion := o.APIVersion
	qAPIVersion := qrAPIVersion
	if qAPIVersion != "" {
		if err := r.SetQueryParam("api-version", qAPIVersion); err != nil {
			return err
		}
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param clusterName
	if err := r.SetPathParam("clusterName", o.ClusterName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
