// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// UpdateRegionClusterReader is a Reader for the UpdateRegionCluster structure.
type UpdateRegionClusterReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateRegionClusterReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateRegionClusterOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewUpdateRegionClusterNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewUpdateRegionClusterInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateRegionClusterDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateRegionClusterOK creates a UpdateRegionClusterOK with default headers values
func NewUpdateRegionClusterOK() *UpdateRegionClusterOK {
	return &UpdateRegionClusterOK{}
}

/*UpdateRegionClusterOK handles this case with default header values.

Details of the updated cluster
*/
type UpdateRegionClusterOK struct {
	Payload *models.Cluster
}

func (o *UpdateRegionClusterOK) Error() string {
	return fmt.Sprintf("[PUT /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] updateRegionClusterOK  %+v", 200, o.Payload)
}

func (o *UpdateRegionClusterOK) GetPayload() *models.Cluster {
	return o.Payload
}

func (o *UpdateRegionClusterOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Cluster)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateRegionClusterNotFound creates a UpdateRegionClusterNotFound with default headers values
func NewUpdateRegionClusterNotFound() *UpdateRegionClusterNotFound {
	return &UpdateRegionClusterNotFound{}
}

/*UpdateRegionClusterNotFound handles this case with default header values.

Not found
*/
type UpdateRegionClusterNotFound struct {
	Payload *models.Error
}

func (o *UpdateRegionClusterNotFound) Error() string {
	return fmt.Sprintf("[PUT /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] updateRegionClusterNotFound  %+v", 404, o.Payload)
}

func (o *UpdateRegionClusterNotFound) GetPayload() *models.Error {
	return o.Payload
}

func (o *UpdateRegionClusterNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateRegionClusterInternalServerError creates a UpdateRegionClusterInternalServerError with default headers values
func NewUpdateRegionClusterInternalServerError() *UpdateRegionClusterInternalServerError {
	return &UpdateRegionClusterInternalServerError{}
}

/*UpdateRegionClusterInternalServerError handles this case with default header values.

Internal server error
*/
type UpdateRegionClusterInternalServerError struct {
	Payload *models.Error
}

func (o *UpdateRegionClusterInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] updateRegionClusterInternalServerError  %+v", 500, o.Payload)
}

func (o *UpdateRegionClusterInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *UpdateRegionClusterInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateRegionClusterDefault creates a UpdateRegionClusterDefault with default headers values
func NewUpdateRegionClusterDefault(code int) *UpdateRegionClusterDefault {
	return &UpdateRegionClusterDefault{
		_statusCode: code,
	}
}

/*UpdateRegionClusterDefault handles this case with default header values.

Error response describing why the operation failed
*/
type UpdateRegionClusterDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the update region cluster default response
func (o *UpdateRegionClusterDefault) Code() int {
	return o._statusCode
}

func (o *UpdateRegionClusterDefault) Error() string {
	return fmt.Sprintf("[PUT /providers/Microsoft.BareMetal/Utilization/Clusters/{clusterName}/Region/{Region}][%d] UpdateRegionCluster default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateRegionClusterDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *UpdateRegionClusterDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
