// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package region

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetRegionsParams creates a new GetRegionsParams object
// with the default values initialized.
func NewGetRegionsParams() *GetRegionsParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionsParams{
		APIVersion: aPIVersionDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetRegionsParamsWithTimeout creates a new GetRegionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetRegionsParamsWithTimeout(timeout time.Duration) *GetRegionsParams {
	var (
		aPIVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionsParams{
		APIVersion: aPIVersionDefault,

		timeout: timeout,
	}
}

// NewGetRegionsParamsWithContext creates a new GetRegionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetRegionsParamsWithContext(ctx context.Context) *GetRegionsParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionsParams{
		APIVersion: apiVersionDefault,

		Context: ctx,
	}
}

// NewGetRegionsParamsWithHTTPClient creates a new GetRegionsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetRegionsParamsWithHTTPClient(client *http.Client) *GetRegionsParams {
	var (
		apiVersionDefault = string("2021-06-01-preview")
	)
	return &GetRegionsParams{
		APIVersion: apiVersionDefault,
		HTTPClient: client,
	}
}

/*GetRegionsParams contains all the parameters to send to the API endpoint
for the get regions operation typically these are written to a http.Request
*/
type GetRegionsParams struct {

	/*APIVersion
	  Version of the API to be used with the client request.

	*/
	APIVersion string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get regions params
func (o *GetRegionsParams) WithTimeout(timeout time.Duration) *GetRegionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get regions params
func (o *GetRegionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get regions params
func (o *GetRegionsParams) WithContext(ctx context.Context) *GetRegionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get regions params
func (o *GetRegionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get regions params
func (o *GetRegionsParams) WithHTTPClient(client *http.Client) *GetRegionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get regions params
func (o *GetRegionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAPIVersion adds the aPIVersion to the get regions params
func (o *GetRegionsParams) WithAPIVersion(aPIVersion string) *GetRegionsParams {
	o.SetAPIVersion(aPIVersion)
	return o
}

// SetAPIVersion adds the apiVersion to the get regions params
func (o *GetRegionsParams) SetAPIVersion(aPIVersion string) {
	o.APIVersion = aPIVersion
}

// WriteToRequest writes these params to a swagger request
func (o *GetRegionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param api-version
	qrAPIVersion := o.APIVersion
	qAPIVersion := qrAPIVersion
	if qAPIVersion != "" {
		if err := r.SetQueryParam("api-version", qAPIVersion); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
