// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package region

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/greenqloud/drp-rest-client/simulator/v3/models"
)

// GetRegionsReader is a Reader for the GetRegions structure.
type GetRegionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRegionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRegionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetRegionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRegionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRegionsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRegionsOK creates a GetRegionsOK with default headers values
func NewGetRegionsOK() *GetRegionsOK {
	return &GetRegionsOK{}
}

/*GetRegionsOK handles this case with default header values.

Region details
*/
type GetRegionsOK struct {
	Payload models.Regions
}

func (o *GetRegionsOK) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Region][%d] getRegionsOK  %+v", 200, o.Payload)
}

func (o *GetRegionsOK) GetPayload() models.Regions {
	return o.Payload
}

func (o *GetRegionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionsNotFound creates a GetRegionsNotFound with default headers values
func NewGetRegionsNotFound() *GetRegionsNotFound {
	return &GetRegionsNotFound{}
}

/*GetRegionsNotFound handles this case with default header values.

Not found
*/
type GetRegionsNotFound struct {
	Payload *models.Error
}

func (o *GetRegionsNotFound) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Region][%d] getRegionsNotFound  %+v", 404, o.Payload)
}

func (o *GetRegionsNotFound) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionsInternalServerError creates a GetRegionsInternalServerError with default headers values
func NewGetRegionsInternalServerError() *GetRegionsInternalServerError {
	return &GetRegionsInternalServerError{}
}

/*GetRegionsInternalServerError handles this case with default header values.

Internal server error
*/
type GetRegionsInternalServerError struct {
	Payload *models.Error
}

func (o *GetRegionsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Region][%d] getRegionsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetRegionsInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegionsDefault creates a GetRegionsDefault with default headers values
func NewGetRegionsDefault(code int) *GetRegionsDefault {
	return &GetRegionsDefault{
		_statusCode: code,
	}
}

/*GetRegionsDefault handles this case with default header values.

Error response describing why the operation failed
*/
type GetRegionsDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the get regions default response
func (o *GetRegionsDefault) Code() int {
	return o._statusCode
}

func (o *GetRegionsDefault) Error() string {
	return fmt.Sprintf("[GET /providers/Microsoft.BareMetal/Utilization/Region][%d] GetRegions default  %+v", o._statusCode, o.Payload)
}

func (o *GetRegionsDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetRegionsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
