// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// Cluster CLuster object representation
//
// swagger:model Cluster
type Cluster struct {

	// Potential number of routes for the customer
	AllocatedRoutes int64 `json:"allocatedRoutes"`

	// Route Limits for cache enabled clusters
	AllocatedRoutesLimit int64 `json:"allocatedRoutesLimit"`

	// Current Az zone of the cluster
	AvailabilityZone string `json:"availabilityZone"`

	// Name of the cluster
	ClusterName string `json:"clusterName"`

	// Physical index of current availability zone
	PhysicalZoneIndex int64 `json:"physicalZoneIndex"`

	// Region of the cluster
	Region string `json:"region,omitempty"`

	// Number of routes currently on the cluster
	RouteCount int64 `json:"routeCount"`

	// Route Limit for the cluster
	RouteLimit int64 `json:"routeLimit"`

	// Field to tell if current cluster uses rotterdam
	SdnApplianceEnabled bool `json:"sdnApplianceEnabled"`

	// Field to tell if rotterdam device is under T1|T2
	SdnAppliancePlacement string `json:"sdnAppliancePlacement"`

	// tier2 spine name for the cluster
	Tier2alias string `json:"tier2alias"`

	// Number of Vrfs currently on the cluster
	VrfCount int64 `json:"vrfCount"`

	// Vrf Limit for the cluster
	VrfLimit int64 `json:"vrfLimit"`
}

// Validate validates this cluster
func (m *Cluster) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *Cluster) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Cluster) UnmarshalBinary(b []byte) error {
	var res Cluster
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
