// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

// Package client implements the Azure ARM Client service API version 2018-09-01-preview.
//
// Microsoft BareMetal Azure Resource Provider specification
package client

// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/Azure/go-autorest/autorest"
)

const (
	// DefaultBaseURI is the default URI used for the service Client
	DefaultBaseURI = "https://management.azure.com"
)

// BaseClient is the base client for Client.
type BaseClient struct {
	autorest.Client
	BaseURI        string
	VnetResourceID string
	Region         string
}

// New creates an instance of the BaseClient client.
func New(vnetResourceID string, region string) BaseClient {
	return NewWithBaseURI(DefaultBaseURI, vnetResourceID, region)
}

// NewWithBaseURI creates an instance of the BaseClient client using a custom endpoint.  Use this when interacting with
// an Azure cloud that uses a non-standard base URI (sovereign clouds, Azure stack).
func NewWithBaseURI(baseURI string, vnetResourceID string, region string) BaseClient {
	return BaseClient{
		Client:         autorest.NewClientWithUserAgent(UserAgent()),
		BaseURI:        baseURI,
		VnetResourceID: vnetResourceID,
		Region:         region,
	}
}
