// Copyright (c) 2020-2021 NetApp, Inc. All rights reserved.

package client

// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/Azure/go-autorest/autorest"
	"github.com/Azure/go-autorest/autorest/date"
)

// The package's fully qualified name.
const fqdn = "github.com/greenqloud/drp-rest-client/v2/client"

// Cluster cLuster object representation
type Cluster struct {
	// ClusterName - Name of the cluster
	ClusterName *string `json:"clusterName,omitempty"`
	// VrfCount - Number of Vrfs currently on the cluster
	VrfCount *int32 `json:"VrfCount,omitempty"`
	// VrfLimit - Vrf Limit for the cluster
	VrfLimit *int32 `json:"vrfLimit,omitempty"`
	// RouteCount - Number of routes currently on the cluster
	RouteCount *int32 `json:"routeCount,omitempty"`
	// RouteLimit - route Limit for the cluster
	RouteLimit *int32 `json:"routeLimit,omitempty"`
	// AllocatedRoutes - Potential number of routes for the customer
	AllocatedRoutes *int32 `json:"allocatedRoutes,omitempty"`
	// Tier2alias - tier2 spine name for the cluster
	Tier2alias *string `json:"tier2alias,omitempty"`
	// SdnApplianceEnabled - Field to tell if current cluster uses rotterdam
	SdnApplianceEnabled *bool `json:"sdnApplianceEnabled,omitempty"`
	// SdnAppliancePlacement - Field to tell if rotterdam device is under T1|T2
	SdnAppliancePlacement *string `json:"sdnAppliancePlacement,omitempty"`
	// LastUpdated - timestamp when the current values were retrieved from the cluster
	LastUpdated *date.Time `json:"lastUpdated,omitempty"`
}

// Error error response describing why the operation failed.
type Error struct {
	// Code - Error code
	Code *string `json:"code,omitempty"`
	// Message - Detailed error message
	Message *string `json:"message,omitempty"`
}

// GetClusterResult result of the request to get information about a cluster
type GetClusterResult struct {
	autorest.Response `json:"-"`
	Clusters          *[]Cluster `json:"Clusters,omitempty"`
}
