// Copyright (c) 2020 NetApp, Inc. All rights reserved.

package log

import (
	"io"

	"github.com/sirupsen/logrus"
)

// SetOutput sets the standard logger output.
var SetOutput func(out io.Writer) = defaultLogger.SetOutput

// SetLevel sets the standard logger level.
var SetLevel func(level logrus.Level) = defaultLogger.SetLevel

// GetLevel returns the standard logger level.
var GetLevel func() logrus.Level = defaultLogger.GetLevel

// AddHook adds a hook to the standard logger hooks.
var AddHook func(hook logrus.Hook) = defaultLogger.AddHook

// WithField creates an entry from the standard cbsLogger and adds a field to
// it. If you want multiple fields, use `WithFields`.
var WithField func(key string, value interface{}) *logrus.Entry = defaultLogger.WithField

// var WithFields func(fields logrus.Fields) *logrus.Entry = defaultLogger.WithFields

// Debug logs a message at level Debug on the standard cbsLogger.
var Debug func(args ...interface{}) = defaultLogger.Debug

// Print logs a message at level Info on the standard cbsLogger.
var Print func(args ...interface{}) = defaultLogger.Print

// Info logs a message at level Info on the standard cbsLogger.
var Info func(args ...interface{}) = defaultLogger.Info

// Warn logs a message at level Warn on the standard cbsLogger.
var Warn func(args ...interface{}) = defaultLogger.Warn

// Warning logs a message at level Warn on the standard cbsLogger.
var Warning func(args ...interface{}) = defaultLogger.Warning

// Error logs a message at level Error on the standard cbsLogger.
var Error func(args ...interface{}) = defaultLogger.Error

// Panic logs a message at level Panic on the standard cbsLogger.
var Panic func(args ...interface{}) = defaultLogger.Panic

// Fatal logs a message at level Fatal on the standard cbsLogger.
var Fatal func(args ...interface{}) = defaultLogger.Fatal

// Debugf logs a message at level Debug on the standard cbsLogger.
var Debugf func(format string, args ...interface{}) = defaultLogger.Debugf

// Printf logs a message at level Info on the standard cbsLogger.
var Printf func(format string, args ...interface{}) = defaultLogger.Printf

// Infof logs a message at level Info on the standard cbsLogger.
var Infof func(format string, args ...interface{}) = defaultLogger.Infof

// Warnf logs a message at level Warn on the standard cbsLogger.
var Warnf func(format string, args ...interface{}) = defaultLogger.Warnf

// Warningf logs a message at level Warn on the standard cbsLogger.
var Warningf func(format string, args ...interface{}) = defaultLogger.Warningf

// Errorf logs a message at level Error on the standard cbsLogger.
var Errorf func(format string, args ...interface{}) = defaultLogger.Errorf

// Panicf logs a message at level Panic on the standard cbsLogger.
var Panicf func(format string, args ...interface{}) = defaultLogger.Panicf

// Fatalf logs a message at level Fatal on the standard cbsLogger.
var Fatalf func(format string, args ...interface{}) = defaultLogger.Fatalf

// Debugln logs a message at level Debug on the standard cbsLogger.
var Debugln func(args ...interface{}) = defaultLogger.Debugln

// Println logs a message at level Info on the standard cbsLogger.
var Println func(args ...interface{}) = defaultLogger.Println

// Infoln logs a message at level Info on the standard cbsLogger.
var Infoln func(args ...interface{}) = defaultLogger.Infoln

// Warnln logs a message at level Warn on the standard cbsLogger.
var Warnln func(args ...interface{}) = defaultLogger.Warnln

// Warningln logs a message at level Warn on the standard cbsLogger.
var Warningln func(args ...interface{}) = defaultLogger.Warningln

// Errorln logs a message at level Error on the standard cbsLogger.
var Errorln func(args ...interface{}) = defaultLogger.Errorln

// Panicln logs a message at level Panic on the standard cbsLogger.
var Panicln func(args ...interface{}) = defaultLogger.Panicln

// Fatalln logs a message at level Fatal on the standard cbsLogger.
var Fatalln func(args ...interface{}) = defaultLogger.Fatalln

// SetReportCaller is true then log message contains function and file information of
// where the log message is produced
var SetReportCaller func(reportCaller bool) = defaultLogger.SetReportCaller

// TODO: add trace level if needed
