package taskqueue

// taskqueue implements a queue to process tasks asynchronously.
// TQueue is intended to be used for non performance critical tasks.
// It has one thread running in background and process Tasks at their scheduled RunAt time,
// and each task is run one by one sequentially.

// Task can be run later than their RunAt time slightly due to the previous task takes
// a long time to finish.

// Task can return additional tasks to be added back to the queue, and task uuids to be cancelled
// in the queue.
// A task can add itself or modified self back to queue by returning a task with the
// same task uuid, but from the user of the queue will always see/peek this task is in the queue.
// This can be used to schedule recurring/periodic tasks.
