package mock

import (
	"github.com/greenqloud/go-lib/log"
	"github.com/greenqloud/hyperscaler-network-client/models/common"
)

type TokenProvider struct {
	additionalMessage string
}

func NewTokenProviderWithMessage(msg string) *TokenProvider {
	log.Infof("Creating a dummy token provider that returns mock token - %v", msg)
	return &TokenProvider{additionalMessage: msg}
}

func (t *TokenProvider) GetAuthenticationToken() (string, error) {
	log.Infof("returning dummy token string - %v", t.additionalMessage)
	return common.MockTokenValue, nil
}
