package azure

// Constants for use with test cases ONLY
const (
	// Dummy Application ID
	DummyApplicationID string = "Dummy_Application_ID"

	// Dummy Tenant ID
	DummyTenantID string = "Dummy_Tenant_ID"

	// Dummy MSI Client ID
	DummyMSIClientID string = "Dummy_Msi_Client_ID"

	// Dummy SP Client ID
	DummySpClientID string = "Dummy_Sp_Client_ID"

	// Dummy Managed Identity Secret
	DummyManagedIdentitySecret string = "Dummy_ManagedIdentity_Secret"

	// Dummy Keyvault Base URL
	DummyKeyVaultBaseURL string = "Dummy_KeyVault_BaseURL"

	// Dummy keyvault secret name in keyvault
	DummyKeyVaultSecretName string = "Dummy_KeyVault_SecretName"

	// Dummy name of azure cloud environment
	DummyAzureCloudName string = "Dummy_Azure_Cloud"
)

var (
	RequiredCredentialsOnly = &Credentials{
		ApplicationID:         DummyApplicationID,
		TenantID:              DummyTenantID,
		MsiManagedIdentityID:  DummyMSIClientID,
		SpManagedIdentityID:   DummySpClientID,
		ManagedIdentitySecret: DummyManagedIdentitySecret,
		KeyVaultBaseURL:       DummyKeyVaultBaseURL,
		KeyVaultSecretName:    DummyKeyVaultSecretName,
		AzureEnvironment:      DummyAzureCloudName,
	}

	AllCredentials = &Credentials{
		ApplicationID:         DummyApplicationID,
		TenantID:              DummyTenantID,
		MsiManagedIdentityID:  DummyMSIClientID,
		SpManagedIdentityID:   DummySpClientID,
		ManagedIdentitySecret: DummyManagedIdentitySecret,
		KeyVaultBaseURL:       DummyKeyVaultBaseURL,
		KeyVaultSecretName:    DummyKeyVaultSecretName,
		AzureEnvironment:      DummyAzureCloudName,
	}
)
