// Copyright (c) 2021 NetApp, Inc. All rights reserved.

package azure

import (
	"github.com/caarlos0/env/v6"
)

// MsiConfig defines the flag required to indicate whether the MSI is disabled or enabled
type MsiConfig struct {
	MsiAuthEnabled bool `env:"MSI_AUTH_ENABLED,required"`
}

// NewMSIConfigFromEnvironment creates a new instance of MsiConfig from environment variables.
// Output:
//	- MsiConfig: A new instance of MsiConfig struct.
// 	- Error, if any.
func NewMSIConfigFromEnvironment() (*MsiConfig, error) {
	msiConfig := MsiConfig{}
	err := env.Parse(&msiConfig)
	if err != nil {
		return nil, err
	}
	return &msiConfig, nil
}
