// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewSnapmirrorRelationshipsPostParams creates a new SnapmirrorRelationshipsPostParams object
// with the default values initialized.
func NewSnapmirrorRelationshipsPostParams() *SnapmirrorRelationshipsPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorRelationshipsPostParamsWithTimeout creates a new SnapmirrorRelationshipsPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorRelationshipsPostParamsWithTimeout(timeout time.Duration) *SnapmirrorRelationshipsPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorRelationshipsPostParamsWithContext creates a new SnapmirrorRelationshipsPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorRelationshipsPostParamsWithContext(ctx context.Context) *SnapmirrorRelationshipsPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorRelationshipsPostParamsWithHTTPClient creates a new SnapmirrorRelationshipsPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorRelationshipsPostParamsWithHTTPClient(client *http.Client) *SnapmirrorRelationshipsPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorRelationshipsPostParams contains all the parameters to send to the API endpoint
for the snapmirror relationships post operation typically these are written to a http.Request
*/
type SnapmirrorRelationshipsPostParams struct {

	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*Info
	  snapmirror information.

	*/
	Info *ntapmodel.PublicSnapmirror
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithTimeout(timeout time.Duration) *SnapmirrorRelationshipsPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithContext(ctx context.Context) *SnapmirrorRelationshipsPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithHTTPClient(client *http.Client) *SnapmirrorRelationshipsPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithFields(fields []string) *SnapmirrorRelationshipsPostParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInfo adds the info to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithInfo(info *ntapmodel.PublicSnapmirror) *SnapmirrorRelationshipsPostParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetInfo(info *ntapmodel.PublicSnapmirror) {
	o.Info = info
}

// WithMaxRecords adds the maxRecords to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithMaxRecords(maxRecords *int64) *SnapmirrorRelationshipsPostParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithOrderBy adds the orderBy to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithOrderBy(orderBy []string) *SnapmirrorRelationshipsPostParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithReturnRecords(returnRecords *bool) *SnapmirrorRelationshipsPostParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorRelationshipsPostParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror relationships post params
func (o *SnapmirrorRelationshipsPostParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorRelationshipsPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
